	.section .note.GNU-stack
	.data
	.globl	str
	.align	8
	.type	str, @object
	.size	str, 8
str:
	.quad	.LC0

	.text
	.globl	func
	.type	func, @function
func:
	push	%rbp
	mov	%rsp, %rbp
	push	%rbx
	push	%rsi
	push	%rdi
	sub	$0x8, %rsp
	mov	str(%rip), %rax
	mov	%rax, %rbx
loop:
	mov	%rbx, %rax
	mov	0x0(%rax), %al
	movsbq	%al, %rax
	mov	%rax, 0x0(%rsp)
	mov	0x0(%rsp), %rax
	mov	$0x0, %rdx
	cmp	%rdx, %rax
	je	end
	mov	$.LC1, %rax
	mov	%rax, %rdi
	mov	0x0(%rsp), %rax
	mov	%rax, %rsi
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	printf
	mov	%rbx, %rsp
	pop	%rbx
	mov	%rbx, %rax
	mov	$0x1, %rdx
	add	%rdx, %rax
	mov	%rax, %rbx
	jmp	loop
end:
	mov	$0x0, %rax
	mov	-0x8(%rbp), %rbx
	mov	-0x10(%rbp), %rsi
	mov	-0x18(%rbp), %rdi
	leave
	ret
	.text
	.globl	main
	.type	main, @function
main:
	push	%rbp
	mov	%rsp, %rbp
	push	%rbx
	push	%rsi
	push	%rdi
	sub	$0x0, %rsp
	push	%rbx
	mov	%rsp, %rbx
	and	$0xfffffffffffffff0, %rsp
	call	func
	mov	%rbx, %rsp
	pop	%rbx
	mov	$0x0, %rax
	mov	-0x8(%rbp), %rbx
	mov	-0x10(%rbp), %rsi
	mov	-0x18(%rbp), %rdi
	leave
	ret

	.data
.LC1:	.string	"%c\n"
.LC0:	.string	"abcdefg"
